package cv05;

import java.util.NoSuchElementException;

/**
 * <p></p>
 *
 * @author Karel Cemus
 */
public class SimpleMap<K, V> implements Map<K, V> {

	/** ulozene pary */
	private Entry[] entries;

	/** pocet vlozenych prvku */
	private int used;

	public SimpleMap() {
		this.used = 0;
		this.entries = new SimpleMap.Entry[2];
	}

	@Override
	public void put(K key, V value) {
		// pokud prvek jeste v kolekci neni
		if (!contains(key)) {
			// over velikost vnitrniho pole
			if (used == entries.length) resize();
			// vloz novy zaznam, pridej na konec
			entries[used++] = new Entry(key, value);
		}
	}

	@Override
	public void remove(K key) {
		// zkus najit prvek
		int index = indexOf(key);

		// pokud prvek je v kolekci
		if (index > -1) {
			// tak ho nahrad poslednim prvkem
			entries[index] = entries[used-1];
			// posledni prvek nyni muzeme uvolnit
			used--;
		}
	}

	public V get(K key) {
		// zkus najit prvek
		int index = indexOf(key);

		if (index > -1) {
			// pokud je prvek v kolekci, tak ho vrat
			return entries[index].value;
		} else {
			// prvek v kolekci neni
			throw new NoSuchElementException("V kolekci neni prvek s klicem " + key);
		}
	}

	@Override
	public boolean contains(K key) {
		return indexOf(key) > -1;
	}

	@Override
	public int size() {
		return used;
	}

	@Override
	public boolean isEmpty() {
		return used == 0;
	}

	private int indexOf(K key) {
		for (int i = 0; i < used; ++i) {
			if (entries[i].key.equals(key)) return i;
		}
		// prvek neni v kolekci
		return -1;
	}

	private void resize() {
		Entry[] array = new SimpleMap.Entry[entries.length * 2];
		for (int i = 0; i < used; ++i) {
			array[i] = entries[i];
		}
		entries = array;
	}

	private class Entry {
		private final K key;
		private final V value;

		private Entry(K key, V value) {
			this.key = key;
			this.value = value;
		}
	}
}
